<%@page import="imagemed.types.enumeration.IMTypebe"%>
<%@page import="imagemed.tables.Table"%>
<%@page
	import="java.util.*,
			imagemed.imtables.ConfigFileResult,
			imagemed.tables.Result,
			imagemed.types.date.TimeStamp,
			imagemed.types.enumeration.IMTypeMODA,
			imagemed.util.*,
			imagemed.imsession.*,
			imagemed.scheduler.SchedulerInterface,
			imagemed.jsputil.*,
			imagemed.dotcom.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%

	IMSession is = new IMSession( request, response, out );
	if ( !is.regOK() ) {
		return;
	}
	is.setNonCacheable();

	String scanmode = is.request.getParameter( "cScanmode" );
	if ( scanmode == null || "".equals( scanmode ) ) {
		scanmode = "normal";
	}

	String type = is.request.getParameter( "type" );
	if ( type == null ) {
		type = "";
	}
	String id = is.request.getParameter( "id" );
	if ( id == null ) {
		id = "";
	}
	String name = is.request.getParameter( "name" );
	if ( name == null ) {
		name = "";
	}
	String savename = is.request.getParameter( "savename" );
	if ( savename == null ) {
		savename = "";
	}
	String settings = is.request.getParameter( "settings" );
	if ( !"true".equals( settings ) ) {
		settings = "false";
	}
	String admin = is.request.getParameter( "cAdmin" );
	if ( admin == null ) {
		admin = "";
	}
	String redir = is.request.getParameter( "cRedir" );
	if ( redir == null ) {
		redir = "";
	}

	String uploadPage = is.request.getParameter( "cUpload" );
	if ( uploadPage == null || "".equals( uploadPage ) ) {
		uploadPage = "/scheduler/upload.jsp";
	}

	String PDF = is.request.getParameter( "cPDF" );
	if ( PDF == null ) {
		PDF = "false";
	}

	String studyIUID = is.request.getParameter( "cStudyIUID" );
	if ( studyIUID == null ) {
		studyIUID = "";
	}

	String seriesUID = is.request.getParameter( "cSeriesUID" );
	if ( seriesUID == null ) {
		seriesUID = "";
	}

	String proposedStudyUID = is.request.getParameter( "cProposedStudyUID" );
	if ( proposedStudyUID == null ) {
		proposedStudyUID = "";
	}

	boolean isGeneric = "yes".equals( is.request.getParameter( "cGeneric" ) );

	boolean isPACSorder = "true".equals( is.request.getParameter( "PACSorder" ) );

	boolean fromPACS = isPACSorder || "".equals( type ); //empty type means PACS study

	boolean isUID = "true".equals( is.request.getParameter( "isUID" ) );

	boolean isUploadOnly = "true".equals( is.request.getParameter( "cUploadOnly" ) );

	String doctypeDefault = is.request.getParameter( "cDoctypeDefault" );

	String refererHost = is.request.getParameter( "RefererHost" );
	String parentSession = is.request.getParameter( "ParentSession" );
	String redirPart = "" + ( refererHost == null ? "" : "&RefererHost=" + refererHost ) + ( parentSession == null ? "" : "&ParentSession=" + parentSession );

	Helper.DEBUG( "Scan.jsp", "Called" );
	Helper.DEBUG( "Scan.jsp", "Type:" + type + " ID:" + id + " Name:" + name + " Savename:" + savename + " Admin:" + admin + " redir:" + redir + " isPACSOrder:" + is.request.getParameter( "PACSorder" ) +
			" ,uploadPage:" + is.request.getParameter( "cUpload" ) );


	String demogParams;
	if ( isPACSorder ) {
		demogParams = "cObjType=study&cID=" + studyIUID;
	}
	else if ( !"".equals( type ) ) {
		demogParams = "cObjType=" + type + "&cID=" + id;
	}
	else { //means PACS study
		demogParams = "cObjType=study&cID=" + studyIUID;
	}

	DualPropsConfigReader scanCfg = new DualPropsConfigReader( IMEnvBase.getEnv( "CONF" ) + "/scan.conf", IMEnvBase.getEnv( "CASES_HOME" ) + "/cfg/scan.conf" );
	Properties scanProps = scanCfg.getProperties();
	String comp = scanProps.getProperty( "jpgcompression", "75" );


	String objType = is.request.getParameter( "cObjType" ); //for 'test' type
	if ( objType == null || "".equals( objType ) ) {
		if ( fromPACS ) {
			if ( isPACSorder ) {
				objType = "PACSorder";
			}
			else {
				objType = "study";
			}
		}
		else {
			objType = type; //order, patient, etc.
		}
	}

	String scheduledDate = "";
	String scheduledTime = "";
	boolean imagesDisabled = false;
	if ( "order".equals( objType ) ) {
		if ( AttachmentManager.getStudyIUIDForOrder( id ) == null ) {
			imagesDisabled = true;
		}
		String orderDate = AttachmentManager.getScheduledDateForOrder( id );
		if ( orderDate != null ) {
			scheduledDate = orderDate;
		}
		String orderTime = AttachmentManager.getScheduledTimeForOrder( id );
		if ( orderTime != null ) {
			scheduledTime = orderTime;
		}
	}
	else if ( "study".equals( objType ) ) {
		String studyDateTime = AttachmentManager.getScheduledDateTimeForStudy( studyIUID );
		TimeStamp ts = new TimeStamp( studyDateTime );
		if ( ts.isValid() ) {
			if ( is.getTimeZone() != null ) {
				ts.convertTo( is.getTimeZone() );
			}
			scheduledDate = ts.getDA();
			if ( ts.hasTime() ) {
				scheduledTime = ts.getTM();
			}
		}
	}
	else if ( "PACSorder".equals( objType ) ) {
		String studyDateTime = AttachmentManager.getScheduledDateTimeForPACSOrder( studyIUID );
		TimeStamp ts = new TimeStamp( studyDateTime );
		if ( ts.isValid() ) {
			if ( is.getTimeZone() != null ) {
				ts.convertTo( is.getTimeZone() );
			}
			scheduledDate = ts.getDA();
			if ( ts.hasTime() ) {
				scheduledTime = ts.getTM();
			}
		}
	}

	//!!!!!!!
	//scanmode = "test";

%><HTML>
<HEAD><TITLE>Scan</TITLE>
<%
	//imagemed.http.tabs.TabBean.writeStyleOnly( is );
	Table.printCommonScript(is);
	JSHelper.printJsInclude( out, JSHelper.LAYOUTSCRIPTS_JS );
%>	
	<script language="JavaScript">
	function doUpload( map ) {
		var frm = self.document.uploadForm;
		if( frm.userfile.value == null || frm.userfile.value == undefined || frm.userfile.value == "" ) {
			alert( "No file selected!" );
			return;
		}
		while (frm.savename.value != frm.userfile.value) {
			frm.savename.value = frm.userfile.value;
		}
		
		//benne lehet meg a c:\fakepath pl. Chrome
		//ezt a lenti dologgal lehetne elvileg szepen kiszedni, de arra inkabb szetfagy :) 
		// ezert aztan inkabb kieszedjuk a fogado oldalon (UploadDicom servlet)
		
		//while( frm.savename.value != self.document.getElementById("userfile").files[0].fileName ) {
		//	frm.savename.value = self.document.getElementById("userfile").files[0].fileName;
		//}

		var doctype = frm.cDocType.value;
		if( map[ doctype ] != null && map[ doctype ].IsImage == "yes" ) {
			// in case of image, we get the possible redirect URL value from targethub
			
			if( frm.cTargetHUB != null && frm.cTargetHUB != undefined && !frm.cTargetHUB.disabled ) {
				frm.action = frm.cTargetHUB.value + frm.cImageUploadURL.value;
			}
			else {
				frm.action = frm.cImageUploadURL.value;
			}
			frm.cIsImage.value = "true";
			

			// calculate and pass study date + time
			if( frm.cDateSelect.value == "Empty" ) {
	//			alert( "Empty" );
				frm.cStudyDate.value = null;
				frm.cStudyTime.value = null;
			}
			else if( frm.cDateSelect.value == "Scheduled Procedure Date/Study Date" ) {
	//			alert( "StudyDate sch.date:" + frm.cScheduledDate.value + " time:" + frm.cScheduledTime.value );
				frm.cStudyDate.value = frm.cScheduledDate.value;
				frm.cStudyTime.value = frm.cScheduledTime.value;
	//			alert( "StudyDate date:" + frm.cStudyDate.value + " time:" + frm.cStudyTime.value );
			} 
			else if( frm.cDateSelect.value == "Current Date" ) {
				var today = new Date();
				var dd = today.getDate();
				var mm = today.getMonth()+1; //January is 0!
				var yyyy = today.getFullYear();
				if(dd<10) {
				    dd = '0'+dd;
				} 
				if(mm<10) {
				    mm = '0'+mm;
				} 
				frm.cStudyDate.value = "" + yyyy + mm + dd;
				var hh = today.getHours();
				if(hh < 10 ) {
					hh = '0'+hh;
				}
				var mi = today.getMinutes();
				if(mi < 10 ) {
					mi = '0'+mi;
				}
				var ss = today.getSeconds();
				if(ss < 10 ) {
					ss = '0'+ss;
				}
				frm.cStudyTime.value = "" + hh + mi + ss;
//				alert( "CurrentDate date:" + frm.cStudyDate.value + " time:" + frm.cStudyTime.value );
			}
		}
		else {
			frm.action = frm.cUploadURL.value;
		}

		// then we delete cTargetHUB, we don't use the html redirect, as it cannot redirect POST
		if( frm.cTargetHUB != null && frm.cTargetHUB != undefined ) {
			frm.cTargetHUB.value = null;
		}

	//	alert( "action:" + frm.action );
		
		frm.submit();
	}
	
	function doctypechange( me, map ) {
		var frm = self.document.uploadForm;
		
		if( map[ me.value ] != null ) {
			if( map[ me.value ].ModalityEdit == 'yes' ) {
				frm.cModality.disabled = false;			
				setValue_select( 'cModality', map[ me.value ].ModalityDefault );
			}
			else {
				frm.cModality.disabled = true;			
			}
	
			if( map[ me.value ].StudyDateEdit == 'yes' ) {
				frm.cDateSelect.disabled = false;			
				setValue_select( 'cDateSelect', map[ me.value ].StudyDateDefault );
			}
			else {
				frm.cDateSelect.disabled = true;			
			}
			
			// targethub may not be present at all
			if( frm.cTargetHUB != null && frm.cTargetHUB != undefined ) {
				if( map[ me.value ].TargetHUBEdit == 'yes' ) {
					frm.cTargetHUB.disabled = false;			
					setValue_select( 'cTargetHUB', map[ me.value ].TargetHUBDefault );
				}
				else {
					frm.cTargetHUB.disabled = true;			
				}
			}
		}

	}

	</script>
</HEAD>
<BODY>
<%
	if ( "fast".equals( scanmode ) ) {
		is.out.println( "Scanning...<BR>" );
	}

	String[] modalities = { "CR", "CT", "DX", "ES", "MG", "MR", "NM", "OT", "RF", "RG", "SC", "US", "XA", "PT" };
	Result res = new ConfigFileResult( "DTMD", "DTMD.lst", null, true, false );
	if ( res.countAll() > 0 ) {
		List<String> modLst = new Vector<String>();
		while ( res.next() )
			modLst.add( res.getValue( "DTMD" ) );
		modalities = modLst.toArray( new String[ modLst.size() ] );
	}
	StringBuilder modalitiesStr = new StringBuilder( modalities[ 0 ] );
	for ( int i = 1; i < modalities.length; i++ ) {
		modalitiesStr.append( '\n' ).append( modalities[ i ] );
	}

	String hubs = "";
	String[] hubList = null;
	List<String> urlList = new ArrayList<String>();
	DotcomDevice selfDevice = DotcomConfig.selfDevice();
	if ( selfDevice != null && selfDevice.isDbOnly() ) {
		hubList = Helper.sortCaseInSensitive( DotcomConfig.getConfig().getHubs( selfDevice.getId(), selfDevice.getId() ).toArray( new String[ 0 ] ) );
		if ( hubList != null ) {
			for ( int i = 0; i < hubList.length; i++ ) {
				hubs += hubList[ i ];
				if ( i < hubList.length - 1 ) {
					hubs += '\n';
				}
				String idBase = RedirectToolbox.getURL( hubList[ i ], is.regIP, null );
				Helper.DEBUG( "added URL:" + idBase + " to hub:" + hubList[ i ] );
				urlList.add( idBase );
			}
		}
	}

	if( isUploadOnly ) {
		// we want the servlet in the upload page
		// parameters will help find out if it's generic (scheduler-type) upload or dicom upload
		uploadPage = "/UploadDicom/";
		
		// doctype: we select the displayed one! (it's the same in the app)
		String behavior = IMTypebe.ORDER;
		if( fromPACS ) {
			behavior = IMTypebe.STUDY;
		}
		
		//csak azokat kuldjuk, ami stimmel (schedulerhez Order, PACShoz study)
		// mindenhez image!?
		List<String> docDisp = AttachmentManager.getDocumentTypesDisplay( behavior );
		if( !imagesDisabled && !"patient".equals( objType ) ) {
			List<String> imageDisp = AttachmentManager.getDocumentTypesDisplay( IMTypebe.IMAGE );
			docDisp.addAll( imageDisp );
		}

		Map<String, IMProperties> doctypeMap = AttachmentManager.getDoctypeDataMap();
		IMProperties docProps = doctypeMap.get( doctypeDefault ); 
		boolean isModalityEnabled = ( docProps == null ? false : "yes".equals( docProps.getProperty( "ModalityEdit" ) ) );
		boolean isStudyDateEnabled = ( docProps == null ? false : "yes".equals( docProps.getProperty( "StudyDateEdit" ) ) );
		// is.httpx_host + 
%>		
		<FORM name="uploadForm" ACTION="<%=uploadPage%>" ENCTYPE=MULTIPART/FORM-DATA METHOD=POST>
		<table cellpadding=2 cellspacing=0 border="1">
			<tr>
				<td valign=center nowrap>
					Document Type
				</td>
				<td valign=center nowrap>
					<select name="cDocType" id="cDocType" onChange='javascript:doctypechange( this, <%=JSHelper.toJSON( doctypeMap )%> )' >
<%
					for( int i = 0; i < docDisp.size(); i++ ) {
						out.println( "<option value=\"" + docDisp.get( i ) + "\"" + ( docDisp.get( i ).equals( doctypeDefault ) ? " selected " : "" ) + ">" + docDisp.get( i ) + "</option>" );
					}
%>					
					</select> 
				</td>
			</tr>
			<tr>
				<td valign=center nowrap>
					Modality
				</td>
				<td valign=center nowrap>
					<select name="cModality" id="cModality" <%= (isModalityEnabled ? "" : " disabled ") %>>
<%
					for( int i = 0; i < modalities.length; i++ ) {
						out.println( "<option value=\"" + modalities[ i ] + "\"" + ( docProps != null && modalities[ i ].equals( docProps.getProperty( "ModalityDefault" ) ) ? " selected " : "" ) + ">" + modalities[ i ] + "</option>" );
					}
%>					
					</select> 
				</td>
			</tr>
			<tr>
				<td valign=center nowrap>
					Study Date
				</td>
				<td valign=center nowrap>
					<select name="cDateSelect" id="cDateSelect" <%= (isStudyDateEnabled ? "" : " disabled ") %>>
<%
					List<String> dateSelect = new ArrayList<String>();
					String opts = Helper.readTextFile( IMEnvBase.getEnv( "CLASSES_HOME" ) + "/imagemed/types/config/DTSD.lst" );
					if( opts != null ) {
						StringTokenizer st = new StringTokenizer( opts, "\n" );
						while( st.hasMoreTokens() ) {
							String line = st.nextToken().trim();
							if( line.length() > 0 ) {
								out.println( "<option value=\"" + line + "\"" + ( docProps != null && line.equals( docProps.getProperty( "StudyDateDefault" ) ) ? " selected " : "" ) + ">" + line + "</option>" );
							}
						}
					}
%>					
					</select> 
				</td>
			</tr>
<%
			// target hub is there for orders & pacsorders AND only if we are DBOnly server
			// this is for the image (order->study) - where it should occur
			// if we are not dbonly, hublist will be null
			
			if( ( "PACSorder".equals( objType ) || "order".equals( objType ) ) && hubList != null ) {
				boolean isEnabled = ( docProps == null ? false : "yes".equals( docProps.getProperty( "TargetHUBEdit" ) ) );
				
				Helper.DEBUG( "defaultdoctype:" + doctypeDefault );
%>
				<tr>
					<td valign=center nowrap>
						Target Hub
					</td>
					<td valign=center nowrap>
						<select name="cTargetHUB" id="cTargetHUB" <%= (isEnabled ? "" : " disabled ") %>>
<%
						for( int i = 0; i < hubList.length; i++ ) {
							out.println( "<option value=\"" + urlList.get( i ) + "\"" + ( docProps != null && hubList[ i ].equals( docProps.getProperty( "TargetHUBDefault" ) ) ? " selected " : "" ) + ">" + hubList[ i ] + "</option>" );
						}
%>					
						</select> 
					</td>
				</tr>
<%
			}
%>			
			<tr>
				<td valign=center nowrap>
					<INPUT TYPE="FILE" ID="userfile" NAME="userfile" <%="".equals( name ) ? " multiple " : ""%> accept=".jpg,.pdf,.tif,.tiff,.bmp,.png">
				</td>
				<td valign=center nowrap>
					<a href='javascript:doUpload( <%=JSHelper.toJSON( doctypeMap )%> )'>
					<%=	JSHelper.getJsLocalizedButton( "BUTTON_UPLOAD", "BUTTON_NULL", false ) %>
					</a>
				</td>
			</tr>
		</table>
		<input TYPE="hidden" NAME="cStudyDate" VALUE="<%=scheduledDate%>" >
		<input TYPE="hidden" NAME="cStudyTime" VALUE="<%=scheduledTime%>" >
		<input TYPE="hidden" NAME="cScheduledDate" VALUE="<%=scheduledDate%>" >
		<input TYPE="hidden" NAME="cScheduledTime" VALUE="<%=scheduledTime%>" >
		<input TYPE="hidden" NAME="cUploadOnly" VALUE="true">
		<input TYPE="hidden" NAME="cRedir" VALUE="<%=is.httpx_host + "/scheduler/refreshandclose.jsp?" + redirPart %>">
		<input TYPE="hidden" NAME="cUploadURL" VALUE="<%=/*is.httpx_host +*/ uploadPage%>" >
		<input TYPE="hidden" NAME="cImageUploadURL" VALUE="<%=/*is.httpx_host + */ "/UploadDicom/"%>" >
		<input TYPE="hidden" NAME="cIsImage" VALUE="false">
		
		<input TYPE="hidden" NAME="type" VALUE="<%=type%>" >
		<input TYPE="hidden" NAME="id" VALUE="<%=id%>" >
		<input TYPE="hidden" NAME="name" VALUE="<%=name%>" >
		<input TYPE="hidden" NAME="savename" VALUE="<%=savename%>" >
		<input TYPE="hidden" NAME="cAdmin" VALUE="<%=admin%>" >
		<input TYPE="hidden" NAME="cStudyIUID" VALUE="<%=studyIUID%>" >
		<input TYPE="hidden" NAME="cSeriesUID" VALUE="<%=seriesUID%>" >
		<input TYPE="hidden" NAME="cProposedStudyUID" VALUE="<%=proposedStudyUID%>" >
		<input TYPE="hidden" NAME="PACSorder" VALUE="<%=isPACSorder ? "true" : "false"%>" >
		<input TYPE="hidden" NAME="cObjType" VALUE="<%=objType%>" >
		<input TYPE="hidden" NAME="isUID" VALUE="<%=isUID ? "true" : "false"%>" >
		
		
		</form>
<%		
	}
	else {
		IMPropsConfigReader debugReader = new IMPropsConfigReader( IMEnvBase.getEnv( "CONF" ) + "/debug.cfg" );
		debugReader.checkAndLoad();
		String debug = ( (IMPropsConfiguration) debugReader.getConfiguration() ).getProperties().getProperty( "scan", "false" );
%>
<%--
 Az upload paramok a Scanner.java-ban is fel vannak sorolva!!! ott is add hozza!!!
 --%>

	<embed
		type = "application/x-java-applet" 
		CODE = "ep.clients.Scanner"
		ARCHIVE = "<%=is.httpx_host + "/applets/epapplets.jar"%>,<%=is.httpx_host + "/applets/jai_codec.jar"%>,<%=is.httpx_host + "/applets/jai_core.jar"%>"
		java_arguments = "-Xmx1024m"
		WIDTH = "<%="fast".equals( scanmode ) ? "350" : "100%"%>"
		HEIGHT = "<%="fast".equals( scanmode ) ? "50" : "100%"%>"
		dllurl = "<%=is.httpx_host + "/scheduler/eRADscan.dll"%>"
		debug = "<%=debug%>"
		redirectAtEnd = "true"
		scanmode = "<%=scanmode%>"
		ModalityList = "<%=Helper.URLEncodeUTF8( modalitiesStr.toString() )%>"
		HUBList = "<%=Helper.URLEncodeUTF8( hubs )%>"
		ScanInterfaceVisible = "<%=settings%>"
		redirURL = "<%="".equals( redir ) ? "" : is.httpx_host + redir%>"
		UploadURL = "<%=is.httpx_host + uploadPage%>"
		closeURL = "<%=is.httpx_host + "/scheduler/refreshandclose.jsp?" + redirPart %>"
		doctypeURL = "<%=is.httpx_host + "/scheduler/getdoctypes.jsp?"  + ( !fromPACS ? ( "cObjType=" + type ) : ( "cObjType=study" ) )%>"
		demogURL = "<%=is.httpx_host + "/cases/getdemographics.jsp?" + demogParams + "&server=" + is.httpx_host + "&sessionid=" + is._sid%>"
		nameNeeded = "<%=( isGeneric || isPACSorder ) ? "yes" : "no"%>"
		saveButton = "<%=( isGeneric || fromPACS ) ? "yes" : "no"%>"
		checkexistURL = "<%=is.httpx_host + "/scheduler/checkexist.jsp?type=" + type + "&id=" + id%>"
		jpgcompression = "<%=comp%>"
		ImageUploadURL = "<%=is.httpx_host + "/cases/uploadDicom.jsp"%>"
		cScheduledDate = "<%=scheduledDate%>"
		cScheduledTime = "<%=scheduledTime%>"
		cImagesDisabled = "<%=imagesDisabled ? "true" : "false"%>"
		cDoctypeDefault = "<%=doctypeDefault%>"
		cUploadRedirect = "<%= selfDevice.isDbOnly() ? "yes" : "no"%>"
		cUploadOnly = "<%=isUploadOnly ? "true" : "false"%>"
		server = "<%=is.httpx_host%>"
		sessionid = "<%=is._sid%>" 
		
		mytype = "<%=type%>"
		id = "<%=id%>"
		myname = "<%=name%>"
		savename = "<%=savename%>"
		cAdmin = "<%=admin%>"
		cStudyIUID = "<%=studyIUID%>"
		cSeriesUID = "<%=seriesUID%>"
		cProposedStudyUID = "<%=proposedStudyUID%>"
		cPDF = "<%=PDF%>"
		PACSorder = "<%=isPACSorder ? "true" : "false"%>"
		cObjType = "<%=objType%>"
		isUID = "<%=isUID ? "true" : "false"%>">
	</embed>
<%
	}
%>

</BODY>
</HTML>
