<%--
 ** Component: scheduler
 **
 ** Description:
 **   this jsp page is for setting a context to a list in Order table
 **   
 **
 ** Parameters: 
 **
 **  @param cContextName	name of the context to update
 **  @param cListName			name of the list to be put into the context
 **
 --%><%@
	page import="imagemed.imsession.*, imagemed.util.*, imagemed.http.IMRequest,
			imagemed.scheduler.SchedulerInterface, imagemed.lists.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%-- Input Parameters --%><%!
	private boolean isValSet(String val) {
		return val != null && val.length() > 0;
	}

%><%
	IMSession is = new IMSession(request, response, out); 
	is.setNonCacheable();
	response.setContentType("text/plain");
	if (!is.regOK()) {
		out.println("#Result=ERROR");
		out.println("#Error=NoReg");
		return;
	}
	String contextName = is.request.getParameter("cContext");
	if (!isValSet(contextName)) {
		out.println("#Result=ERROR");
		out.println("#Error=No cContext");
		return;
	}
	String listName = is.request.getParameter("cListName");
	if (!isValSet(listName)) {
		out.println("#Result=ERROR");
		out.println("#Error=No cListName");
		return;
	}
	
	SchedulerInterface.sendServerTime( is );

//	listName = Helper.URLDecode( listName );
	
	
	RecFile contextFile = IMRequest.getContextFile( is.getUser(), is._sid, contextName );
	
	IMProperties props = new IMProperties();
	if( !"default".equals( listName ) ) {
		props.setProperty("cList_" + ListType.SCHEDULER_ORDER.getIndex(), listName );
	}

	contextFile.save( props );
	out.println("#Result=OK");
	out.println("#Reload=true");
	if (true) {
		return;
	}
%>